<template>
  <li class="cart__item product">
    <div class="product__pic">
      <img :src="item.product.image" width="120" height="120" alt="item.product.title" />
    </div>
    <h3 class="product__title">{{ item.product.title }}</h3>
    <!-- <p class="product__info">Объем: <span>128GB</span></p> -->
    <span class="product__code">Артикул: {{ item.product.id }} </span>

    <div class="product__counter form__counter">
      <!-- button - -->
      <button type="button" aria-label="Убрать один товар" @click.prevent="removeProduct">
        <svg width="10" height="10" fill="currentColor" :disabled="{ disabled: amount == 0 }">
          <use xlink:href="#icon-minus"></use>
        </svg>
      </button>

      <input type="text" v-model.number="amount" name="count" />
      <!-- button + -->
      <button type="button" aria-label="Добавить один товар" @click.prevent="addProduct">
        <svg width="10" height="10" fill="currentColor"><use xlink:href="#icon-plus"></use></svg>
      </button>
    </div>

    <b class="product__price"> {{ (item.quantity * item.product.price) | numberFormat }} ₽ </b>

    <button
      class="product__del button-del"
      type="button"
      aria-label="Удалить товар из корзины"
      @click.prevent="deleteProduct(item.product.id)"
    >
      <svg width="20" height="20" fill="currentColor">
        <use xlink:href="#icon-close"></use>
      </svg>
    </button>
  </li>
</template>

<script>
import numberFormat from '@/helpers/numberFormat'
import {mapActions} from 'vuex'

export default {
  filters: { numberFormat },
  props: ['item'],
  computed: {
    amount: {
      get() {
        return this.item.quantity
      },
      set(value) {
        this.$store.dispatch('updateCartProductAmount', {
          productId: this.item.product.id,
          quantity: value,
        })
      },
    },
  },
  methods: {
    ...mapActions({ deleteProduct: 'deleteCartProduct' }),
    removeProduct() {
      if (this.item.quantity > 0) {
        this.amount = this.amount - 1
      }
    },
    addProduct() {
      if (this.item.quantity < 999) {
        this.amount = this.amount + 1
      }
    },
  },
}
</script>
